local module = DorHUDMod:new("PDTH++", { abbr = "PDTH++",
	author = "kfcdragon756", bundled = "standard", categories="Gameplay changing", version = "v1.33", description = {
	chinese = "收获日：掠夺的游戏体验不够丰富，而这个大修就是尽可能在有限的内容里添加尽可能多的丰富度。",
	english = "The gameplay variety is still not enough, and this overhaul is just trying to add as much variety as possible in limited contents.",
	},
	dependencies = {
		"[nwpab]",
		"[static_recoil]",
		"[bwr]",
		"[Alleviations Weapon Rework]",
		"[1° A.W.U. Rebalance]",
		"[yet_another_weapon_rebalance]",
		"[ovk_193]",
		"[hitmarkers]",
		"[Realistic Rof]",
	},
	includes = { { "mod_localization", { type = "localization" } } },
})
--This binding function is for cable tie skill.
module:add_menu_option("tie_yourself", {
	type = "keybind",
	name = {
		english = "Tie-yourself with skill",
		chinese = "用技能把自己绑起来",
	}
})


module:hook("OnKeyPressed", "tie_yourself", nil, "GAME", function(self)
	local state_name = managers.player:player_unit():movement():current_state_name()
	if not managers.player:player_unit() then
		return
	end
	if not managers.player._equipment.specials.extra_cable_tie then
		return
	end
	if not managers.player._equipment.specials.cable_tie then
		return
	end
	if not state_name == "standard" then
		return
	end
	managers.player:remove_special("cable_tie")
	managers.player:player_unit():movement():on_disarmed()
end)


--sandbox
module:hook_post_require("lib/managers/achievmentmanager.", "sandbox/achievmentmanager")
module:hook_post_require("lib/network/matchmaking/networkaccountsteam", "sandbox/NetworkAccountSTEAM")
module:hook_post_require("lib/network/matchmaking/networkmatchmakingsteam", "sandbox/NetworkMatchMakingSTEAM")
module:hook_post_require("lib/managers/savefilemanager", "sandbox/savefile")
--player weapon
module:hook_post_require("lib/tweak_data/playertweakdata", "weapon_stuff/playertweakdata")
module:hook_post_require("lib/tweak_data/weapontweakdata", "weapon_stuff/weapontweakdata")
module:hook_post_require("lib/units/weapons/raycastweaponbase", "weapon_stuff/shieldpiercing")
module:hook_post_require("lib/units/weapons/shotgun/shotgunbase", "weapon_stuff/shotgunbase")
module:hook_post_require("lib/managers/gameplaycentralmanager", "weapon_stuff/shieldpiercing")
module:hook_post_require("lib/units/cameras/fpcameraplayerbase", "weapon_stuff/FPCameraPlayerBase")
module:hook_post_require("lib/units/beings/player/states/playerstandard", "weapon_stuff/playerstandard")
module:hook_post_require("lib/units/beings/player/states/playertased", "weapon_stuff/playertased")
module:hook_post_require("lib/units/weapons/raycastweaponbase", "weapon_stuff/fire_sound_fix")
module:hook_post_require("lib/units/weapons/raycastweaponbase", "weapon_stuff/raycastweaponbase")
module:register_post_override("lib/units/weapons/grenades/m79grenadebase", "weapon_stuff/m79grenadebase")
--enemies
module:hook_post_require("lib/tweak_data/charactertweakdata", "enemies/charactertweakdata")
module:hook_post_require("core/lib/units/coreunitdamage", "enemies/coreunitdamage")
module:hook_post_require("lib/units/enemies/cop/copdamage", "enemies/copdamage")
module:hook_post_require("lib/units/enemies/cop/copbase", "enemies/copbase")
module:hook_post_require("lib/units/civilians/logics/civilianlogicescort", "enemies/civilianlogicescort")
--difficulty
module:hook_post_require("lib/tweak_data/groupaitweakdata", "difficulties/groupaitweakdata")
module:hook_post_require("lib/tweak_data/charactertweakdata", "difficulties/charactertweakdata")
module:hook_post_require("lib/tweak_data/playertweakdata", "difficulties/playertweakdata")
--deployables
module:hook_post_require("lib/units/weapons/raycastweaponbase", "deployables/pickupdeployables")
module:hook_post_require("lib/tweak_data/equipmentstweakdata", "deployables/equipmentstweakdata")
module:hook_post_require("lib/units/pickups/ammoclip", "deployables/pickupdeployables")
module:hook_post_require("lib/managers/playermanager", "deployables/pickupdeployables")
module:hook_post_require("lib/units/equipment/ammo_bag/ammobagbase", "deployables/pickupdeployables")
--module:hook_post_require("lib/units/equipment/sentry_gun/sentrygunbase", "deployables/sentrygunbase")
module:hook_post_require("lib/units/weapons/trip_mine/tripminebase", "deployables/tripminebase")
--tweakdata
module:hook_post_require("lib/tweak_data/upgradestweakdata","tweakdata/upgradestweakdata")
--equipments & crew bonuses and less shake on hit.
module:hook_post_require("lib/units/beings/player/playerdamage", "equipment_overhaul/playerdamage")
module:hook_post_require("lib/units/beings/player/playermovement", "equipment_overhaul/playermovement")

--disable some mods that may conflict with this mod.
module:hook("OnModuleRegistered", "load_KO", function()
	D:unregister_module("anticheat")
	D:unregister_module("save_slot_selector")
	D:unregister_module("Auto Fire Sound Fix")
	D:unregister_module("wtfbm")
end)
--some mutators will be fun.
module:hook("OnModuleLoading", "load_mutators", function(module)
	--prevents that you load mutator without loading ovk_193, it will crash the game.
	local ovk_193 = D:module("ovk_193")
	if not ovk_193 or (ovk_193 and not ovk_193:enabled()) then
		return
	end
	--unload mutator packages.
	module:hook_post_require("lib/setups/gamesetup", "mutator/gamesetup")

	--this will prevent the mutator conflictions. (some mutators will break another mutator)
	module:hook_post_require("lib/managers/menumanager", "mutator/menumanager")
	module:hook_post_require("lib/managers/menumanagerdialogs", "mutator/menumanagerdialogs")
	
	local mutator_availability = { all = true }
	if MutatorHelper.setup_mutator(module, "zhouji", mutator_availability, nil, true) then
		module:hook_post_require("lib/tweak_data/weapontweakdata", "mutator/zhouji/weapontweakdata")
		module:hook_post_require("lib/tweak_data/playertweakdata", "mutator/zhouji/playertweakdata")
	end
	if MutatorHelper.setup_mutator(module, "full_speed", mutator_availability, nil, true) then
		module:hook_post_require("lib/tweak_data/charactertweakdata", "mutator/full_speed/charactertweakdata")
		module:hook_post_require("lib/tweak_data/playertweakdata", "mutator/full_speed/playertweakdata")
	end
	if MutatorHelper.setup_mutator(module, "kaboom", mutator_availability, nil, true) then
		module:hook_post_require("lib/tweak_data/weapontweakdata", "mutator/kaboom/weapontweakdata")
	end
	mutator_availability = { overkill = {}, overkill_145 = {} }
	if MutatorHelper.setup_mutator(module, "exercised_cops", mutator_availability, nil, true) then
		module:hook_post_require("lib/tweak_data/charactertweakdata", "mutator/exercised_cops/charactertweakdata")
		module:hook_post_require("lib/tweak_data/groupaitweakdata", "mutator/exercised_cops/groupaitweakdata")
	end
	mutator_availability = { overkill = {}, overkill_145 = {} }
	if MutatorHelper.setup_mutator(module, "combine_assault", mutator_availability, nil, true) then
		module:hook_post_require("lib/tweak_data/groupaitweakdata", "mutator/combine_assault/groupaitweakdata")
		module:hook_post_require("lib/setups/gamesetup", "mutator/combine_assault/gamesetup")
	end
	mutator_availability = { all = true }
	if MutatorHelper.setup_mutator(module, "expert_mode", mutator_availability, nil, true) then
		module:hook_post_require("lib/tweak_data/playertweakdata", "mutator/expert_mode/playertweakdata")
		module:hook_post_require("lib/tweak_data/weapontweakdata", "mutator/expert_mode/weapontweakdata")
		module:hook_post_require("lib/units/weapons/raycastweaponbase", "mutator/expert_mode/raycastweaponbase")
		module:hook_post_require("lib/tweak_data/charactertweakdata", "mutator/expert_mode/charactertweakdata")
		module:hook_post_require("lib/units/enemies/spooc/actions/lower_body/actionspooc", "mutator/expert_mode/actionspooc")
		module:hook_post_require("lib/units/beings/player/states/playertased", "mutator/expert_mode/playertased")
	end
	mutator_availability = { all = true }
	if MutatorHelper.setup_mutator(module, "no_time_for_searching", mutator_availability, nil, true) then
		module:hook_post_require("lib/tweak_data/weapontweakdata", "mutator/no_time_for_searching/weapontweakdata")
		module:hook_post_require("lib/units/enemies/cop/copdamage", "mutator/no_time_for_searching/copdamage")
	end
	
end, false)
return module